DEFINE VARIABLE m AS MEMPTR NO-UNDO.
SET-SIZE(m) = 200000.
DISPLAY "Allocate memptr: " GET-SIZE(m) SKIP.

SET-SIZE(m) = 0.
DISPLAY "Resetted memptr: " GET-SIZE(m) SKIP. 

SET-SIZE(m) = 400000. /* 2147483647: seems like P4GL only support 32 bit setter here regardless 
                           of -noint64 parameter. However, probably memory resources restrict 
                           this parameter evem more. On the other side, on P2J the size of the 
                           variable is also limited by java heap limit! */
DISPLAY "Realloc memptr:  " GET-SIZE(m) SKIP.

CURRENT-VALUE(my-seq-1) = 2147483647 * 2147483647.
DYNAMIC-CURRENT-VALUE("my-seq-1", "p2j_test") = 2147483647 * 2147483647 + 2147483647.

DISPLAY "ETIME:                         " ETIME FORMAT "->>>>>>>>>>>>>>>>>>>9" SKIP.
DISPLAY "CURRENT-VALUE(my-seq-1):       " CURRENT-VALUE(my-seq-1) FORMAT "->>>>>>>>>>>>>>>>>>>9" SKIP.
DISPLAY "DYNAMIC-CURRENT-VALUE(my-seq-1)" DYNAMIC-CURRENT-VALUE("my-seq-1", "p2j_test")  FORMAT "->>>>>>>>>>>>>>>>>>>9" SKIP .
DISPLAY "DYNAMIC-NEXT-VALUE(my-seq-1)   " DYNAMIC-NEXT-VALUE("my-seq-1", "p2j_test")  FORMAT "->>>>>>>>>>>>>>>>>>>9" SKIP .
DISPLAY "INTERVAL since DATE(0)         " INTERVAL(NOW, DATETIME(DATE(0)), "milliseconds") FORMAT "->>>>>>>>>>>>>>>>>>>9" SKIP.
DISPLAY "DYNAMIC-NEXT-VALUE(my-seq-1)   " NEXT-VALUE(my-seq-1) FORMAT "->>>>>>>>>>>>>>>>>>>9" SKIP.

DEFINE VARIABLE oioioi AS INT64.    /* int64 variables can be defined in -noint64 mode */
/* DISPLAY oioioi.                  -- but they cannot be accessed */
/* oioioi = 10.                     -- but they cannot be accessed */

/* Expected outout:
┌─────────────────────────────────────────────────────┐
│Allocate memptr:     200,000                         │
│Resetted memptr:           0                         │
│Realloc memptr:      400,000                         │
│ETIME:                                       16303493│
│CURRENT-VALUE(my-seq-1):          4611686016279904256│
│DYNAMIC-CURRENT-VALUE(my-seq-1)   4611686016279904256│
│DYNAMIC-NEXT-VALUE(my-seq-1)      4611686016279904259│
│INTERVAL since DATE(0)                212232158029628│
│DYNAMIC-NEXT-VALUE(my-seq-1)      4611686016279904262│
└─────────────────────────────────────────────────────┘
*/