PROCEDURE boo:
    DEF INPUT PARAMETER foo AS DATE.
    DISPLAY foo.
END.

RUN boo(?).

Pause.


define variable ii as integer init 1.
define variable jj as int64   init ?.

display " ii > jj :" ii > jj " ii < jj :" ii < jj skip.

ii = 2000000000.
display ii + 0 format ">>>,>>>,>>>,>>9".

ii = 2147483647.
jj = ii + 2.
display ii + 2 format ">>>,>>>,>>>,>>9".
display jj + 2 format ">>>,>>>,>>>,>>9".

ii = 3000000000 / 2.0.
display ii + 0 format ">>>,>>>,>>>,>>9".

ii = ?.
ii = jj no-error.
display ii + 0 format ">>>,>>>,>>>,>>9" skip.




DEF VAR x AS INTEGER.
DEF VAR y AS INTEGER.
DEF VAR z AS INTEGER.
DEF VAR big AS INT64.
DEF VAR d AS DECIMAL.
DEF FRAME f.

/* NOTE: as far as the compiler is concerned, x + y is an INTEGER*/
/* NOTE: all failures are RUNTIME failures, not COMPILER failures*/
x = 2000000000. /*should succeed, just under 2gig*/
y = 2000000000. /*should succeed, just under 2gig*/


DISPLAY x + y FORMAT ">>>,>>>,>>>,>>>" . /*should succeed if format is big enough*/

/* z = x + y.       -- assignment >2gig to INTEGER should fail*/
/* INTEGER(x + y).  -- INTEGER function on >2gig should fail*/

big = x + y.    /*assignment >2gig to INT64 should succeed*/

DISPLAY x + y > 2000000000.     /*compare >2gig with INTEGER constant should succeed*/
DISPLAY x + y > 3000000000.     /*compare >2gig with INT64 constant should succeed */

PROCEDURE myproc:
    DEF INPUT PARAMETER mp AS INTEGER LABEL "As INTEGER:".
    DISPLAY mp FORMAT ">>>,>>>,>>>,>>>" SKIP WITH FRAME f SIDE-LABELS.
END.
PROCEDURE myproc2:
    DEF INPUT PARAMETER mp2 AS INT64 LABEL "As INT64:".
    DISPLAY mp2 FORMAT ">>>,>>>,>>>,>>>" SKIP WITH FRAME f SIDE-LABELS.
END.
PROCEDURE myproc3:
    DEF INPUT PARAMETER mp3 AS DECIMAL LABEL "As DECIMAL:".
    DISPLAY mp3 FORMAT "->,>>>,>>>,>>9.99" SKIP WITH FRAME f SIDE-LABELS.
END.


/* unknown literals */
RUN myproc(?).  /*INTEGER expression should succeed*/
RUN myproc2(?). /*INTEGER expression should succeed*/
RUN myproc3(?). /*INTEGER expression should succeed*/
PAUSE MESSAGE "unknown literals (?)".

/* small literals */
RUN myproc(101).  /*INTEGER expression should succeed*/
RUN myproc2(101). /*INTEGER expression should succeed*/
RUN myproc3(101). /*INTEGER expression should succeed*/
PAUSE MESSAGE "small literals (101)".

/* large literals */
RUN myproc (3000000000) NO-ERROR.  /*INT64 expression should fail*/
RUN myproc2(3000000000). /*INT64 expression should succeed*/
RUN myproc3(3000000000). /*INT64 expression should succeed*/
PAUSE MESSAGE "large literals (3000000000)".

/* small decimal literals */
RUN myproc(101.2).  /*small decimal expression should succeed*/
RUN myproc2(101.2). /*small decimal expression should succeed*/
RUN myproc3(101.2). /*small decimal expression should succeed*/
PAUSE MESSAGE "small decimal literals (101.2)".

/* large decimal literals */
RUN myproc(3000000000.1) NO-ERROR.  /* large decimal expression should fail*/
RUN myproc2(3000000000.1). /*large decimal expression should succeed*/
RUN myproc3(3000000000.1). /*large decimal expression should succeed*/
PAUSE MESSAGE "large decimal literals (3000000000.1)".

/* INTEGER variables */
RUN myproc(X).  /*INTEGER expression should succeed*/
RUN myproc2(X). /*INTEGER expression should succeed*/
RUN myproc3(X). /*INTEGER expression should succeed*/
PAUSE MESSAGE "INTEGER variables (X = 2000000000)".

/* small INT64 variables */
big = 314.
RUN myproc(big).  /*small INT64 expression should succeed*/
RUN myproc2(big). /*small INT64 expression should succeed*/
RUN myproc3(big). /*small INT64 expression should succeed*/
PAUSE MESSAGE "small INT64 variables (big = 314)".

/* large INT64 variables */
big = 4000000000.
RUN myproc(big) NO-ERROR.  /*large INT64 expression should fail*/
RUN myproc2(big). /*large INT64 expression should succeed*/
RUN myproc3(big). /*large INT64 expression should succeed*/
PAUSE MESSAGE "large INT64 variables (big = 4000000000)".

/* small decimal variables */
d = 6.12.
RUN myproc(d).  /*small decimal expression should succeed*/
RUN myproc2(d). /*small decimal expression should succeed*/
RUN myproc3(d). /*small decimal expression should succeed*/
PAUSE MESSAGE "small decimal variables (d = 6.12)".

/* large decimal variables */
d = 5000000000.1.
RUN myproc(d) NO-ERROR.  /*large decimal expression should fail*/
RUN myproc2(d). /*large decimal expression should succeed*/
RUN myproc3(d). /*large decimal expression should succeed*/
PAUSE MESSAGE "large decimal variables (d = 5000000000.1)".


big + x. /*is compiled as returning INT64*/
x + y. /*is compiled as returning INTEGER*/


